solution_nongrid<-function(a,b,C,sparse=FALSE){
  tic<-proc.time()
  if (sparse==FALSE){
    count<-length(a$mass)
    N<-sqrt(count)
    plan<-transport(a,b,p=2)
    p.length<-length(plan$from)
    B<-Matrix(0,(p.length+1),(p.length+1))
    c.rhs<-rep(0,(p.length+1))
    for (j in 1:p.length){
      f<-plan$from[j]
      t<-plan$to[j]
      B[j,f]<-1
      B[j,(count+t)]<-(1)
      c.rhs[j]<-C[f,t]
    }
    B[(p.length+1),(p.length+1)]<-1
    B<-Matrix(as.vector(B),(p.length+1),(p.length+1),sparse = TRUE)
    sol_dual<-Matrix::solve(B,c.rhs)
  }
  else{
    count<-length(a$mass)
    N<-sqrt(count)
    plan<-transport(a,b,p=2)
    p.length<-length(plan$from)
    B<-Matrix(0,(p.length+1),(p.length+1),sparse=TRUE)
    c.rhs<-rep(0,(p.length+1))
    for (j in 1:p.length){
      f<-plan$from[j]
      t<-plan$to[j]
      B[j,f]<-1
      B[j,(count+t)]<-(1)
      c.rhs[j]<-C[f,t]
    }
    B[(p.length+1),(p.length+1)]<-1
    sol_dual<-Matrix::solve(B,c.rhs)
  }
  #print(proc.time()-tic)
  return(sol_dual)
}
